<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SigGen: /home/x/siggen/lib/include/Options.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
  $(document).ready(initResizable);
/* @license-end */</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SigGen
   &#160;<span id="projectnumber">1.0</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('_options_8h_source.html','');});
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Options.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#include &quot;ThreadingPolicy.h&quot;</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="keyword">namespace </span>siggen</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;{</div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;    <span class="keyword">enum class</span> ParseConfigResult : int</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;    {</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;          <a class="code" href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934eae0aa021e21dddbd6d8cecec71e9cf564">OK</a>                </div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;        , <a class="code" href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934ea483616ae6efa01b5ab2c9a7f63f84d68">QuitOnHelp</a>        </div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;    };</div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div>
<div class="line"><a name="l00020"></a><span class="lineno"><a class="line" href="classsiggen_1_1_options.html">   20</a></span>&#160;    <span class="keyword">class </span><a class="code" href="classsiggen_1_1_options.html">Options</a></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    {</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;        std::string m_InputFileName;                        </div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;        std::string m_OutputFileName;                       </div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;        <span class="keywordtype">size_t</span> m_BlockSizeDefault { 1024 * 1024 };          </div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;        <span class="keywordtype">size_t</span> m_BlockSize { 1024 * 1024 };                 </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;        uint32_t m_ThreadCount { 0 };                       </div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;        uint32_t m_ThreadPolicy { PowerSaver };             </div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;        uint32_t m_LogLevel { 0 };                          </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;        std::string m_HashName;                             </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="classsiggen_1_1_options.html#a93b4e1f79b1751cd74e8069639709467">   33</a></span>&#160;        std::string <span class="keyword">const</span> &amp; <a class="code" href="classsiggen_1_1_options.html#a93b4e1f79b1751cd74e8069639709467">GetInputFileName</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> m_InputFileName; }</div>
<div class="line"><a name="l00035"></a><span class="lineno"><a class="line" href="classsiggen_1_1_options.html#aecd9d4cc9b7d8186f6e81de6d2eb3ffe">   35</a></span>&#160;        std::string <span class="keyword">const</span> &amp; <a class="code" href="classsiggen_1_1_options.html#aecd9d4cc9b7d8186f6e81de6d2eb3ffe">GetOutputFileName</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> m_OutputFileName; }</div>
<div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="classsiggen_1_1_options.html#a1bf946ed370154884b1a82076f1b8a4a">   37</a></span>&#160;        <span class="keywordtype">size_t</span> <a class="code" href="classsiggen_1_1_options.html#a1bf946ed370154884b1a82076f1b8a4a">GetBlockSize</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> m_BlockSize; }</div>
<div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="classsiggen_1_1_options.html#a753c4f80f87f9a512c197afae09731fb">   39</a></span>&#160;        uint32_t <a class="code" href="classsiggen_1_1_options.html#a753c4f80f87f9a512c197afae09731fb">GetThreadCount</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> m_ThreadCount; }</div>
<div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="classsiggen_1_1_options.html#a261be4a780e4a23e133252e56281ddb1">   41</a></span>&#160;        ThreadingPolicy <a class="code" href="classsiggen_1_1_options.html#a261be4a780e4a23e133252e56281ddb1">GetThreadPolicy</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> static_cast&lt;ThreadingPolicy&gt;(m_ThreadPolicy); }</div>
<div class="line"><a name="l00043"></a><span class="lineno"><a class="line" href="classsiggen_1_1_options.html#a0d21253deaca59e2f6f15b5cac5c783a">   43</a></span>&#160;        uint32_t <a class="code" href="classsiggen_1_1_options.html#a0d21253deaca59e2f6f15b5cac5c783a">GetLogLevel</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> m_LogLevel; }</div>
<div class="line"><a name="l00045"></a><span class="lineno"><a class="line" href="classsiggen_1_1_options.html#a75e7b584ae17ee0010389232f1195b54">   45</a></span>&#160;        std::string <span class="keyword">const</span> &amp; <a class="code" href="classsiggen_1_1_options.html#a75e7b584ae17ee0010389232f1195b54">GetHashName</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> m_HashName; }</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div>
<div class="line"><a name="l00048"></a><span class="lineno"><a class="line" href="classsiggen_1_1_options.html#a2a83396bdb1535acb324b827d064ac6f">   48</a></span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_options.html#a2a83396bdb1535acb324b827d064ac6f">SetInputFileName</a> (std::string <span class="keyword">const</span> &amp; name) { m_InputFileName = name; }</div>
<div class="line"><a name="l00050"></a><span class="lineno"><a class="line" href="classsiggen_1_1_options.html#ae80870de22ad6438c8b886ff70c75eff">   50</a></span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_options.html#ae80870de22ad6438c8b886ff70c75eff">GetOutputFileName</a> (std::string <span class="keyword">const</span> &amp; name) { m_OutputFileName = name; }</div>
<div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="classsiggen_1_1_options.html#a29f02029bc74a0212fd506a99e0b36ef">   52</a></span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_options.html#a29f02029bc74a0212fd506a99e0b36ef">SetBlockSize</a> (<span class="keywordtype">size_t</span> size) { m_BlockSize = size; }</div>
<div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="classsiggen_1_1_options.html#aa2797de5dce12cb7751c942504e51074">   54</a></span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_options.html#aa2797de5dce12cb7751c942504e51074">SetThreadCount</a> (uint32_t count) { m_ThreadCount = count; }</div>
<div class="line"><a name="l00056"></a><span class="lineno"><a class="line" href="classsiggen_1_1_options.html#a80cdeac333c31612aa82608fcd1c7a41">   56</a></span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_options.html#a80cdeac333c31612aa82608fcd1c7a41">SetThreadPolicy</a> (ThreadingPolicy policy) { m_ThreadPolicy = policy; }</div>
<div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="classsiggen_1_1_options.html#ad716c1fe100084bd024029671caab830">   58</a></span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_options.html#ad716c1fe100084bd024029671caab830">SetLogLevel</a> (uint32_t level) { m_LogLevel = level; }</div>
<div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="classsiggen_1_1_options.html#a064a446867e9329820973dbcf3fae9af">   60</a></span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classsiggen_1_1_options.html#a064a446867e9329820973dbcf3fae9af">SetHashName</a> (std::string <span class="keyword">const</span> &amp; name) { m_HashName = name; }</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        ParseConfigResult <a class="code" href="classsiggen_1_1_options.html#ab4f252a399a19ddfc05a35984859b15d">ParseCommandLine</a> (<span class="keywordtype">int</span> argc, <span class="keywordtype">char</span> * argv[]);</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    };</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160; </div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;} <span class="comment">// namespace siggen</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<div class="ttc" id="aclasssiggen_1_1_options_html_a064a446867e9329820973dbcf3fae9af"><div class="ttname"><a href="classsiggen_1_1_options.html#a064a446867e9329820973dbcf3fae9af">siggen::Options::SetHashName</a></div><div class="ttdeci">void SetHashName(std::string const &amp;name)</div><div class="ttdoc">set user specified hash function name</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00060">Options.h:60</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a0d21253deaca59e2f6f15b5cac5c783a"><div class="ttname"><a href="classsiggen_1_1_options.html#a0d21253deaca59e2f6f15b5cac5c783a">siggen::Options::GetLogLevel</a></div><div class="ttdeci">uint32_t GetLogLevel() const</div><div class="ttdoc">return user specified verbosity</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00043">Options.h:43</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a261be4a780e4a23e133252e56281ddb1"><div class="ttname"><a href="classsiggen_1_1_options.html#a261be4a780e4a23e133252e56281ddb1">siggen::Options::GetThreadPolicy</a></div><div class="ttdeci">ThreadingPolicy GetThreadPolicy() const</div><div class="ttdoc">return user specified threading policy</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00041">Options.h:41</a></div></div>
<div class="ttc" id="amain_8cpp_html_a6a7b0d312786823650a6f0b9ff0f934ea483616ae6efa01b5ab2c9a7f63f84d68"><div class="ttname"><a href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934ea483616ae6efa01b5ab2c9a7f63f84d68">ReturnCodes::QuitOnHelp</a></div><div class="ttdoc">help was invoked</div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a75e7b584ae17ee0010389232f1195b54"><div class="ttname"><a href="classsiggen_1_1_options.html#a75e7b584ae17ee0010389232f1195b54">siggen::Options::GetHashName</a></div><div class="ttdeci">const std::string &amp; GetHashName() const</div><div class="ttdoc">return user specified hash function name</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00045">Options.h:45</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html"><div class="ttname"><a href="classsiggen_1_1_options.html">siggen::Options</a></div><div class="ttdoc">configuration for generation of signatures file</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00020">Options.h:20</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_ae80870de22ad6438c8b886ff70c75eff"><div class="ttname"><a href="classsiggen_1_1_options.html#ae80870de22ad6438c8b886ff70c75eff">siggen::Options::GetOutputFileName</a></div><div class="ttdeci">void GetOutputFileName(std::string const &amp;name)</div><div class="ttdoc">set user specified output file name</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00050">Options.h:50</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a753c4f80f87f9a512c197afae09731fb"><div class="ttname"><a href="classsiggen_1_1_options.html#a753c4f80f87f9a512c197afae09731fb">siggen::Options::GetThreadCount</a></div><div class="ttdeci">uint32_t GetThreadCount() const</div><div class="ttdoc">return user specified number of threads (0 == auto)</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00039">Options.h:39</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a29f02029bc74a0212fd506a99e0b36ef"><div class="ttname"><a href="classsiggen_1_1_options.html#a29f02029bc74a0212fd506a99e0b36ef">siggen::Options::SetBlockSize</a></div><div class="ttdeci">void SetBlockSize(size_t size)</div><div class="ttdoc">set user specified block size</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00052">Options.h:52</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a93b4e1f79b1751cd74e8069639709467"><div class="ttname"><a href="classsiggen_1_1_options.html#a93b4e1f79b1751cd74e8069639709467">siggen::Options::GetInputFileName</a></div><div class="ttdeci">const std::string &amp; GetInputFileName() const</div><div class="ttdoc">return user specified input file name</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00033">Options.h:33</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_ab4f252a399a19ddfc05a35984859b15d"><div class="ttname"><a href="classsiggen_1_1_options.html#ab4f252a399a19ddfc05a35984859b15d">siggen::Options::ParseCommandLine</a></div><div class="ttdeci">ParseConfigResult ParseCommandLine(int argc, char *argv[])</div><div class="ttdoc">reads options from command line</div><div class="ttdef"><b>Definition:</b> <a href="_options_8cpp_source.html#l00008">Options.cpp:8</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_ad716c1fe100084bd024029671caab830"><div class="ttname"><a href="classsiggen_1_1_options.html#ad716c1fe100084bd024029671caab830">siggen::Options::SetLogLevel</a></div><div class="ttdeci">void SetLogLevel(uint32_t level)</div><div class="ttdoc">set user specified verbosity</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00058">Options.h:58</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_aa2797de5dce12cb7751c942504e51074"><div class="ttname"><a href="classsiggen_1_1_options.html#aa2797de5dce12cb7751c942504e51074">siggen::Options::SetThreadCount</a></div><div class="ttdeci">void SetThreadCount(uint32_t count)</div><div class="ttdoc">set user specified number of threads (0 == auto)</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00054">Options.h:54</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a1bf946ed370154884b1a82076f1b8a4a"><div class="ttname"><a href="classsiggen_1_1_options.html#a1bf946ed370154884b1a82076f1b8a4a">siggen::Options::GetBlockSize</a></div><div class="ttdeci">size_t GetBlockSize() const</div><div class="ttdoc">return user specified block size</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00037">Options.h:37</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_aecd9d4cc9b7d8186f6e81de6d2eb3ffe"><div class="ttname"><a href="classsiggen_1_1_options.html#aecd9d4cc9b7d8186f6e81de6d2eb3ffe">siggen::Options::GetOutputFileName</a></div><div class="ttdeci">const std::string &amp; GetOutputFileName() const</div><div class="ttdoc">return user specified output file name</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00035">Options.h:35</a></div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a2a83396bdb1535acb324b827d064ac6f"><div class="ttname"><a href="classsiggen_1_1_options.html#a2a83396bdb1535acb324b827d064ac6f">siggen::Options::SetInputFileName</a></div><div class="ttdeci">void SetInputFileName(std::string const &amp;name)</div><div class="ttdoc">set user specified input file name</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00048">Options.h:48</a></div></div>
<div class="ttc" id="amain_8cpp_html_a6a7b0d312786823650a6f0b9ff0f934eae0aa021e21dddbd6d8cecec71e9cf564"><div class="ttname"><a href="main_8cpp.html#a6a7b0d312786823650a6f0b9ff0f934eae0aa021e21dddbd6d8cecec71e9cf564">ReturnCodes::OK</a></div><div class="ttdoc">success</div></div>
<div class="ttc" id="aclasssiggen_1_1_options_html_a80cdeac333c31612aa82608fcd1c7a41"><div class="ttname"><a href="classsiggen_1_1_options.html#a80cdeac333c31612aa82608fcd1c7a41">siggen::Options::SetThreadPolicy</a></div><div class="ttdeci">void SetThreadPolicy(ThreadingPolicy policy)</div><div class="ttdoc">set user specified threading policy</div><div class="ttdef"><b>Definition:</b> <a href="_options_8h_source.html#l00056">Options.h:56</a></div></div>
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_97aefd0d527b934f1d99a682da8fe6a9.html">lib</a></li><li class="navelem"><a class="el" href="dir_5a30104352ef4255dc24354b02eb2d20.html">include</a></li><li class="navelem"><b>Options.h</b></li>
    <li class="footer">Generated by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.16 </li>
  </ul>
</div>
</body>
</html>
